<?
	include "funclib.php";
	include "redisFunc.php";

	redis_conn();
	$aa = redis_keys("ping:*");
	begin_ping($aa);
	redis_close();
	
	function begin_ping( $aa=array() )
	{
		foreach( $aa as $key )
		{
			if( ($m=redis_incr($key))>1 )
				continue;

			// 產生錯誤的key
			$errKey   = "error:".$key;
			$alertKey = "alert:".$key;
			
			$ip = substr($key,8);
			$n = ping($ip);
			// 如果執行正確 進行下一筆
			if( $n>0 && $n<3000 )
			{
				if( ($fp=fopen("run.log","a")) )
				{
					fputs($fp,$ip."\t".$n." ms\n");
					fclose($fp);
				}
				
				if( redis_exists($alertKey) )
					redis_del($alertKey);
				
				// 如果之前有錯誤 刪除錯誤的記錄
				if( redis_exists($errKey) && ($times=redis_get($errKey))>=3 )
				{
					redis_del($errKey);
					$dkey = substr($key,5);
					$data = redis_get( $dkey );
					$message = str_replace( ":", " ", $dkey );
					$message.= " ping time ".$n." ms 恢復正常 (".$times."次錯誤)\n".$data;

					if( ($fp=fopen("error.log","a")) )
					{
						fputs($fp, date("Y/m/d H:i:s")." ".$message."\n\n");
						fclose($fp);
					}

					sendGCM( $message );
				}
					
				continue;
			}
			
			$errTimes = redis_incr($errKey);
			
			switch( $errTimes )
			{
				case 1:	// 如果第1次錯誤, 設定保留20分鐘
					redis_expire($alertKey, 1200);
					break;
					
				case 3:
					redis_expire($errKey,86400);
					
					// 取出線路編號及報修電話
					$dkey = substr($key,5);
					$data = redis_get( $dkey );
					$tm   = date("Y/m/d H:i:s");
					$message = str_replace( ":", " ", $dkey );	
					$message.= ($n==0) ? " ping Unreachable" : " ping time ".$n." ms";
					$message.= "\n\n".$data;

					if( ($fp=fopen("error.log","a")) )
					{
						fputs($fp, $tm." ".$message."\n\n");
						fclose($fp);
					}

					// echo $message."\n";
					sendGCM( $message );
					break;
			}
		}
	}
	
	
	function sendGCM( $message="" )
	{
		if( $message=="" )
			return "";

		$hh = intval( date("H") );
		if( $hh>7 && $hh<23 )
    	$msg = $message;
		else
  		$msg = date("m/d H:i:s")."\n".$message;

    $para = "TAG=sendEMP";;
    $para.= "&senderId=sChkIP";
    $para.= "&senderName=".urlencode("ping IP");
    $para.= "&emp_id=gp_se_manager,gp_se_network";
   	$para.= "&message=".urlencode($msg);
			
    // 發送GCM
    $headers = array("Content-Type: application/x-www-form-urlencoded");

		$result = "";
		$hh = intval( date("H") );
		if( $hh>7 && $hh<23 )
		{
	    $ch = curl_init();
	    curl_setopt( $ch, CURLOPT_URL, "http://ec-monitor.fmt.com.tw:1688/gcm/service.php?ID=momoIT" );
	    curl_setopt( $ch, CURLOPT_POST, true );
	    curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
	    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

	    curl_setopt( $ch, CURLOPT_POSTFIELDS, $para );
	    $result = curl_exec($ch);
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);	    
	    curl_close($ch);
  	}
  	else // 放入 redis 等到7:00排成起來再發送
  	{
			$key = "gcm:queue:count";
			if( ($id=redis_incr($key))>0 )
			{
				// 設定存放10小時
				$key = "gcm:queue:".$id.":message";
				redis_set( $key, $para, 36000);
				$result = "queue";
			}
  	}
  	
    return $result;
	}
	
  function ping($host)
  {
    $str = osCommand("ping $host -c 3 -W 5| grep icmp_seq");
    $str = str_replace("\r","",$str);
    $aa = explode("\n",$str);
    $tt = $i = 0;
    foreach( $aa as $str )
    {
      $bb = explode(" ",$str);
      if( count($bb)!=8 )
      	continue;
     
      $ms = str_replace("time=","",$bb[6]);
      $tt+= $ms;
      $i++;
    }
    
    if( $tt>0 )
    	$tt = number_format($tt/$i,2);

    return $tt;
  }	
	
	function ping_old($host) 
	{
    $package = "\x08\x00\x19\x2f\x00\x00\x00\x00\x70\x69\x6e\x67";

    /* create the socket, the last '1' denotes ICMP */    
    $socket = socket_create(AF_INET, SOCK_RAW, 1);
    
    /* set socket receive timeout to 1 second */
    socket_set_option($socket, SOL_SOCKET, SO_RCVTIMEO, array("sec" => 1, "usec" => 0));
    
    /* connect to socket */
    socket_connect($socket, $host, null);
    
    /* record start time */
    list($start_usec, $start_sec) = explode(" ", microtime());
    $start_time = ((float) $start_usec + (float) $start_sec);
    
    socket_send($socket, $package, strlen($package), 0);
    
    $ms = 0;
    if(@socket_read($socket, 255)) 
    {
      list($end_usec, $end_sec) = explode(" ", microtime());
      $end_time = ((float) $end_usec + (float) $end_sec);
      $total_time = $end_time - $start_time;
      $ms = $total_time*1000;
    }
    socket_close($socket);
    
    return $ms;
}
?>