<?
  $redis = "";
  $expire_ttl = 172800;
  $check_date = 86400;

  function redis_conn()
  {      
    global $redis;
    $redis = new Redis();
    $redis->connect( "127.0.0.1", 6379 );
  }
 
  function redis_close()
  {
    global $redis;
    if( $redis )
    	$redis->close();
  }

  function redis_incr($key="",$v=1)
  {
	  global $redis;
	  $ret = 0;
	  if( $redis && $key!="" )
        $ret = $redis->incr($key,$v);
	         
	  return $ret;
  }

  function redis_hgetall($key="")
  {
    global $redis;
    $ret = "";
    if( $redis && $key!="" )
        $ret = $redis->hgetall($key);
    return $ret;
  }
 
  function redis_keys($key="")
  {
    global $redis;
    $ret = array();
    if( $redis && $key!="" )
        $ret = $redis->keys($key);
    return $ret;
  }

  function redis_expire($key="",$ttl=3600)
  {
    global $redis;
    $ret = false;
    if( $redis && $key!="" )
    {
        if( $redis->exists($key) )
            $ret = $redis->expire($key,$ttl);
    }
           
    return $ret;
  }

  function redis_hsetnx($key="",$field="",$val="")
  {
    global $redis;
    $ret = "";
    if( $redis && $key!="" && $field!="" )
        $ret = $redis->hsetnx($key, $field, $val);
           
    return $ret;
  }

  function redis_setnx($key="",$val="")
  {
    global $redis;
    $ret = "";
    if( $redis && $key!="" )
        $ret = $redis->setnx($key, $val);
           
    return $ret;
  }
 
  function redis_set($key="",$val="",$ttl=-1)
  {
    global $redis, $expire_ttl;
    $ret = "";
    if( $redis && $key!="" )
    {
        if( $ttl<0 )
            $ttl = $expire_ttl;
       
        $ret = $redis->set($key, $val, $ttl);
    }
    return $ret;
  }
 
  function redis_get($key="")
  {
    global $redis;
    $ret = "";
    if( $redis && $key!="" )
    {
        if( $redis->exists($key) )
	          $ret = $redis->get($key);
    }
    return $ret;
  }
  
  function redis_del($key="")
  {
  	global $redis;
  	$ret = false;
    if( $redis && $key!="" )
    {
        if( $redis->exists($key) )
	          $ret = $redis->del($key);
    }
    return $ret;
  }
 
  function redis_exists($key="")
  {
    global $redis;
    if( $key=="" )
        return false;
    return $redis->exists($key);
  }

?>