<?
include "redisFunc.php";

$recursive_count = 0;
$httpErrorCode = array(
0   => "ERR_EMPTY_CONTENT",
100 => "Continue",
101 => "Switching Protocols",
200 => "OK",
201 => "Created",
202 => "Accepted",
203 => "Non-Authoritative Information",
204 => "No Content",
205 => "Reset Content",
206 => "Partial Content",
300 => "Multiple Choices",
301 => "Moved Permanently",
302 => "Moved Temporarily",
303 => "See Other",
304 => "Not Modified",
305 => "Use Proxy",
400 => "Bad Request",
401 => "Unauthorized",
402 => "Payment Required",
403 => "Forbidden",
404 => "Not Found",
405 => "Method Not Allowed",
406 => "Not Acceptable",
407 => "Proxy Authentication Required",
408 => "Request Time-out",
409 => "Conflict",
410 => "Gone",
411 => "Length Required",
412 => "Precondition Failed",
413 => "Request Entity Too Large",
414 => "Request-URI Too Large",
415 => "Unsupported Media Type",
500 => "Internal Server Error",
501 => "Not Implemented",
502 => "Bad Gateway",
503 => "Service Unavailable",
504 => "Gateway Time-out",
505 => "HTTP Version not supported"
);

// EC_APP 首頁
$ecapp_url= "http://www.momoshop.com.tw/api/moecapp/api/goods/getMainPage/";

redis_conn();
$ch = curl_init();

$page = $pageSize = 0;
for( $page=0; $page<=$pageSize; $page++ )
{
	$postData = json_encode( array("pageIndex" => $page), JSON_FORCE_OBJECT);
	$response = curl_post_call($ecapp_url, $postData);
	$obj = json_decode ( $response );
	
	// var_dump($obj);

	if( $page==0 )
	{
		$pageSize = $obj->{"pageSize"};
		if( intval($pageSize)<=0 )
			break;
		continue;
	}
	
	if( !isset( $obj->{"success"} ) )
		continue;

	if( !$obj->{"success"} )
		continue;
	
	if( !isset( $obj->{"mainInfo"} ) )
		continue;

	$max = count($obj->{"mainInfo"});
	// var_dump( $obj->{"mainInfo"} );

	$aType = array(
	 1 => "edm",
	 2 => "menu",
	 3 => "title",
	 4 => "loud1",
	 5 => "loud2",
	 6 => "banner1",
	 7 => "banner2",
	 8 => "banner3",
	 9 => "goods1",
	10 => "goods2_limit",
	11 => "goods2_normal",
	12 => "goods3",
	13 => "other"
	);
	foreach( $obj->{"mainInfo"} as $mainInfo )
	{
		if( !isset($mainInfo->{"type"}) )
			continue;
			
		// 取得 首頁排版類型
		$type  = $mainInfo->{"type"};
		$ctype = $aType[$type];
		
		foreach( $mainInfo as $info )
		{
			if( is_numeric($info) )
				continue;

			$max = count($info);
			for( $i=0; $i<$max; $i++ )
			{
				//echo "type($type)=$ctype ";
				switch($type)
				{
					case 1: // edm
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【type=$type edm】圖檔錯誤" );
						curl( $link   , "【type=$type edm】連結錯誤" );
						// echo "[edm][$i] $picture -> $link\n";
						break;
						
					case 2: // menu
						if( !isset($info[$i]->{"menu"}->{"menuName"}) )
							break;
						$menuName   = $info[$i]->{"menu"}->{"menuName"};
						$menuIcon   = $info[$i]->{"menu"}->{"menuIcon"};
						$actionType = $info[$i]->{"action"}->{"actionType"};
						$link       = $info[$i]->{"action"}->{"actionValue"};
						curl( $menuIcon, "【type=$type menu】$menuName Icon錯誤" );
						
						if( substr($link,0,4)=="http" )
							curl( $link    , "【type=$type menu】$menuName 連結錯誤" );
						else
							$link = "".$link;

						// 檢查連結
						if( $actionType==1 )
						{
							curl( $link    , "【type=$type menu】$menuName 連結錯誤" );
						}
						elseif( $actionType==10 ) // 分類頁
						{
							$matches = array();
							preg_match("([0-9]{10})",$link, $matches);
							if( count($matches)<1 )
								continue;
							$link = "http://m.momoshop.com.tw/cateGoods.momo?cn=".$matches[0];
							curl( $link    , "【type=$type menu】】$menuName\n[分類頁] 連結錯誤" );
						}
						//echo "[menu][$i] $menuName $menuIcon -> $link\n";
						break;
						
					case 3: // 限時搶購 今日秒殺 ... BAR
						if( !isset($info[$i]->{"title"}->{"picture"}) )
							break;
						$picture    = $info[$i]->{"title"}->{"picture"};
						curl( $picture, "【type=$type title】圖檔錯誤" );
						// echo "$picture\n";
						break;
						
					case 4: // loud1 熱門快訊
						if( !isset($info[$i]->{"loud"}->{"loudIcon"}) )
							break;
							
						$loudIcon   = $info[$i]->{"loud"}->{"loudIcon"};
						$title      = $info[$i]->{"loud"}->{"title"};
						$subTitle   = $info[$i]->{"loud"}->{"subTitle"};
						$actionType = $info[$i]->{"action"}->{"actionType"};
						$link       = $info[$i]->{"action"}->{"actionValue"};
						
						// 檢查圖檔
						curl( $loudIcon, "【type=$type loud1】$title 圖檔錯誤" );
						
						// 檢查連結
						if( $actionType==1 )
						{
							curl( $link    , "【type=$type loud1】$title 連結錯誤" );
						}
						elseif( $actionType==10 ) // 分類頁
						{
							$matches = array();
							preg_match("([0-9]{10})",$link, $matches);
							if( count($matches)<1 )
								continue;
							$link = "http://m.momoshop.com.tw/cateGoods.momo?cn=".$matches[0];
							curl( $link    , "【type=$type loud1】$title 連結錯誤" );
						}
						
						// echo "[loud1][$i] $title $subTitle -> $loudIcon -> $link\n";
						break;
						
					case 5: // loud2 大聲公
						if( !isset($info[$i]->{"loud"}->{"loudIcon"}) )
							break;
						$loudIcon  = $info[$i]->{"loud"}->{"loudIcon"};
						$title     = $info[$i]->{"loud"}->{"title"};
						$subTitle  = $info[$i]->{"loud"}->{"subTitle"};
						$goodsCode = $info[$i]->{"action"}->{"actionValue"};

						// curl( $link    , "【type=$type loud2】$title\n大聲公商品頁 連結錯誤" );

						// 檢查商品頁連結
						chkGoodsCode( $goodsCode, "【type=$type loud2】$title\n大聲公商品頁 連結錯誤" );
						break;
						
					case 6: // banner1 活動
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture   = $info[$i]->{"banner"}->{"picture"};
						$goodsCode = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【$type banner1】活動 圖檔錯誤" );

						// 檢查商品頁連結
						chkGoodsCode( $goodsCode, "【$type banner1】活動 連結錯誤" );
						break;
						
					case 7: // banner2 活動
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【type=$type banner2】活動 圖檔錯誤" );
						curl( $link   , "【type=$type banner2】活動 連結錯誤" );
						// echo "[banner2][$i] $picture -> $link\n";
						break;
						
					case 8: // banner3 活動
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【type=$type banner3】活動 圖檔錯誤" );
						curl( $link   , "【type=$type banner3】活動 連結錯誤" );
						// echo "[banner3][$i] $picture -> $link\n";
						break;
						
					case 9: // goods1
						if( !isset($info[$i]->{"mainGoods"}->{"goodsCode"}) )
							break;
						$goodsCode = $info[$i]->{"mainGoods"}->{"goodsCode"};
						$name      = $info[$i]->{"mainGoods"}->{"name"};
						$subTitle  = $info[$i]->{"mainGoods"}->{"subTitle"};
						$picture   = $info[$i]->{"mainGoods"}->{"picture"};
						
						// 檢查圖檔
						curl( $picture, "【type=$type goods1】$name 圖檔錯誤" );
						
						// 檢查商品頁連結
						chkGoodsCode( $goodsCode, "【type=$type goods1】$name 連結錯誤" );
						break;
						
					case 10: // goods2_limit 限時搶購
						if( !isset($info[$i]->{"limitBuyItem"}->{"fsCode"}) )
							break;
						$fsCode    = $info[$i]->{"limitBuyItem"}->{"fsCode"};
						$goodsCode = $info[$i]->{"limitBuyItem"}->goods->{"goodsCode"};
						$name      = $info[$i]->{"limitBuyItem"}->goods->{"name"};
						$picture   = $info[$i]->{"limitBuyItem"}->goods->{"picture"};
						//echo "限時搶購 -> $picture\n";
						$matches = array();
						preg_match("([1-2][0-1][0-9][0-9][0-1][0-9][0-3][0-9])",$fsCode, $matches);
						if( count($matches)<1 )
							continue;
						$dir = $matches[0];
						
						// 檢查圖檔
						curl( $picture , "【type=$type goods2_limit】$goodsCode $name\n[限時搶購] 圖檔錯誤" );

						// 檢查商品頁連結
						chkGoodsCode( $goodsCode, "【type=$type goods2_limit】$goodsCode $name\n[限時搶購] 連結錯誤" );

						// 檢查限時搶購的圖
						//$jpg = "https://m.momoshop.com.tw/ecm/img/online/app/limitbuy/".$dir."/".$fsCode.".jpg";

						// echo "[goods2_limit][$i] $name $goodsCode -> $jpg -> $picture\n";
						break;

					case 11: // goods2_normal
						if( !isset($info[$i]->{"mainGoods"}->{"goodsCode"}) )
							break;
						$goodsCode = $info[$i]->{"mainGoods"}->{"goodsCode"};
						$name      = $info[$i]->{"mainGoods"}->{"name"};
						$picture   = $info[$i]->{"mainGoods"}->{"picture"};
						// echo "[goods2_normal][$i] $name -> $picture -> $link\n";

						// 檢查圖檔
						curl( $picture , "【type=$type goods2_normal】$name 圖檔錯誤" );

						// 檢查商品頁連結
						chkGoodsCode( $goodsCode, "【type=$type goods2_normal】$name 連結錯誤" );
						break;

					case 12: // goods3 電視購物
						if( !isset($info[$i]->{"mainGoods"}->{"goodsCode"}) )
							break;
						$goodsCode = $info[$i]->{"mainGoods"}->{"goodsCode"};
						$name      = $info[$i]->{"mainGoods"}->{"name"};
						$picture   = $info[$i]->{"mainGoods"}->{"picture"};

						// 檢查圖檔
						curl( $picture , "【type=$type goods3】$goodsCode $name 圖檔錯誤" );

						// 檢查商品頁連結
						chkGoodsCode( $goodsCode, "【type=$type goods3】$goodsCode $name 商品頁 連結錯誤" );
						break;

					case 13: // other 最下方促銷商品
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						// echo "[other][$i] $picture -> $link\n";
						curl( $picture , "【type=$type 最下方促銷商品】圖檔錯誤" );
						curl( $link    , "【type=$type 最下方促銷商品】連結錯誤" );
						
						break;

				}
				//echo "\n";
			}
		}
	}
}
curl_close($ch);
redis_close();
exit;
 
	function curl_post_call($url,$data)
	{
    $headers= array('Accept: application/json','Content-Type: application/json');
    $handle=curl_init();
    curl_setopt($handle, CURLOPT_URL, $url);
    curl_setopt($handle, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($handle, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($handle, CURLOPT_POST, true);
    curl_setopt($handle, CURLOPT_POSTFIELDS, $data);
     
    $response= curl_exec($handle);
    $code= curl_getinfo($handle,CURLINFO_HTTP_CODE);
     
    return $response;
	}

	// 檢查商品頁的連結
	function chkGoodsCode( $goodsCode, $msg )
	{
		if( $goodsCode=="" )
			return;

		// 檢查商品品號是否正確
		if( strlen($goodsCode)==6 || strlen($goodsCode)==7 )
			$url = "http://m.momoshop.com.tw/goods.momo?i_code=".$goodsCode;
		elseif( substr($goodsCode,0,4)=="http" )
			$url = $goodsCode;
		else
			$url = "";
	
		// 檢查連結
		if( $url=="" )
		{
			// 如果有發生錯誤 , key 存在10分鐘內不檢查
	   	$key = "ecapp:".$goodsCode;
	  	if( redis_exists($key) )
	  		return;
	  	
	  	// 設定10分鐘內不再發送相同的訊息
	  	redis_set( $key, "", 600 );
	  	
	  	$ok = sendGCM( "goodsCode=".$goodsCode."\n".$msg );
	  	echo date("Y/m/d H:i:s")." ".$msg." [".$ok."]\n";
	  }
		else // 檢查連結是否正常
			curl( $url, $msg );
	}
	
	function curl( $url="", $msg="", $recursive=false )
	{
		global $ch, $httpErrorCode, $recursive_count;
		if( $url=="" || $msg=="" )
			return "";

		if( $recursive )
			$recursive_count++;
		else
			$recursive_count = 0;

		if( $recursive_count>=2 )
			return;
		elseif( $recursive_count>0 )
			echo date("Y/m/d H:i:s")." recursive(".$recursive_count.") -> $url\n";

		// 如果有發生錯誤 , key 存在10分鐘內不檢查
   	$key = "ecapp:".$url;
  	if( redis_exists($key) )
  		return;
		
  	curl_setopt($ch, CURLOPT_URL, $url );
  	curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_POST, 0 );
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLINFO_HEADER_OUT, 1); // capture the header info
		curl_setopt($ch, CURLOPT_VERBOSE, 1); // turn verbose on
    curl_setopt($ch, CURLOPT_COOKIEJAR, "COOKIEJAR");
    
    $result = curl_exec($ch);
    
    // 取得header值
		$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		$totTime  = curl_getinfo($ch, CURLINFO_TOTAL_TIME);
		// 如果大於10秒, 再試一次
    if( $totTime>=10 || $httpCode==0 )
    {
    	$result = curl( $url,$msg, true );
    }
    elseif( $httpCode>200 )
    {
			if( isset($httpErrorCode[$httpCode]) )
				$err = $httpErrorCode[$httpCode];
			else
				$err = "";
				
    	$msg = "httpCode=".$httpCode." ".$err."\n".$msg."\n".$url;
    	$ok = sendGCM( $msg );
    	echo date("Y/m/d H:i:s")." ".$msg." [".$ok."] ".$key."\n";
    	
    	// 將錯誤的url記錄600秒
			redis_set( $key, $msg, 600 );
    }

    return $result;
	}

	function sendGCM( $message="" )
	{
		if( $message=="" )
			return;

		$senderId   = "ecapp00";
		$senderName = "ecapp首頁監控";
		// $empId      = "01170";
		$empId      = "gp_it_manager,gp_se_manager,gp_ap_manager,gp_ap_momoshop,gp_ap_app,gp_J1010";

    // 發送GCM
    $headers = array("Content-Type: application/x-www-form-urlencoded");
   
    $para = "TAG=sendEMP";
    $para.= "&senderId=".$senderId;
    $para.= "&senderName=".urlencode($senderName);
    $para.= "&emp_id=".$empId;
    $para.= "&message=".urlencode($message);

		//echo $para."\n\n";
		
    $ch = curl_init();
    curl_setopt( $ch, CURLOPT_URL, "http://ec-monitor.fmt.com.tw:1688/gcm/service.php?ID=momoIT" );
    curl_setopt( $ch, CURLOPT_POST, true );
    curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

    curl_setopt( $ch, CURLOPT_POSTFIELDS, $para );
    $result = curl_exec($ch);
    curl_close($ch);
    return $result;
	}

?>