<?
class ssh2 
{
  private $host = null;
  private $user = null;
  private $port = 22;
  private $password = null;
  private $conn = null;
  private $shell_type = null;
  private $shell = null;
  private $log = "";

	private $methods = array(
	  							'kex' => 'diffie-hellman-group1-sha1',
	  'client_to_server' 	=> array( 'crypt' => '3des-cbc','comp' 	=> 'none'),
	  'server_to_client' 	=> array( 'crypt' => 'aes256-cbc,aes192-cbc,aes128-cbc', 'comp' => 'none')
  );

  function __construct( $host="", $port=0, $callbacks=array() )
  {
  	if( $host!="" ) 
    	$this->host = $host;
     	
    if( $port!=0 ) 
     	$this->port = $port;

    $this->conn = ssh2_connect($this->host, $this->port);
     
    if( !$this->conn )
    {
       $this->log .= "Connection failed !\n";
       return false;
    }
    return true;
  }

	function authPassword( $user="", $password="" )
  {
  	error_reporting(0);

  	if( $user!="" )
  		$this->user = $user;
  		
    if( $password!="" )
    	$this->password = $password;

		$ret = false;
    if( !ssh2_auth_password( $this->conn, $this->user, $this->password ) )
       $this->log .= "Authorization failed !\n";
    else
    	$ret = true;
    
    error_reporting(E_ALL);
    return $ret;
  }

  function openShell( $shell_type="" ) 
  {
    if ( $shell_type=="" )
    	$this->shell_type = "xterm";
    else
    	$this->shell_type = $shell_type;

    $this->shell = ssh2_shell( $this->conn,  $this->shell_type );
    
    if( !$this->shell )
    	$this->log .= " Shell connection failed !\n";

  }

  function writeShell( $command="" ) 
  {
    fwrite($this->shell, $command."\n");
  }

  function cmdExec( $cmd="" )
  {
		if( $cmd=="" )
			return;

    $stream = ssh2_exec( $this->conn, $cmd );
    stream_set_blocking( $stream, true );
    return stream_get_contents($stream);
    /*
    $ret = "";
    while( !feof($stream) )
    	$ret.=fread( $stream, 4096 );

    fclose($stream);
    
    return $ret;
    */
  }

	function putFile( $localFile="", $remoteFile="", $create_mode=0644 )
	{
		if( $localFile=="" || $remoteFile=="" )
			return false;
	
		if( file_exists($localFile) )	
			return ssh2_scp_send($this->conn, $localFile, $remoteFile, $create_mode );
		else
			return false;
	}

	function getFile( $remoteFile="", $localFile="" )
	{
		if( $localFile=="" || $remoteFile=="" )
			return false;
	
		return ssh2_scp_recv($this->conn, $remoteFile, $localFile);
	}


	function sftp_putFile( $localFile="", $remoteFile="" )
	{
		$sftp = ssh2_sftp( $this->conn );
		$stream = @fopen( "ssh2.sftp://".$sftp.$remoteFile, "w" );

		if( !$stream )
		{
			$this->log.= "Could not open remote file: $remoteFile.\n";
			return false;
		}
			
		$data_to_send = @file_get_contents($localFile);
		if( !$data_to_send )
		{
			@fclose($stream);
			$this->log.= "Could not open local file: $localFile.\n";
			return false;
		}
				
		if( !@fwrite($stream, $data_to_send) )
		{
			@fclose($stream);
			$this->log.= "Could not send data from file: $localFile.\n";
			return false;
		}
			
		@fclose($stream);
		return true;
	}

	function sftp_getFile( $remoteFile="", $localFile="" )
	{
		$sftp = ssh2_sftp( $this->conn );
		$stream = @fopen( "ssh2.sftp://".$sftp.$remoteFile, "r" );

		if( !$stream )
		{
			$this->log.= "Could not open remote file: $remoteFile.\n";
			return false;
		}
			
		$contents = fread($stream,filesize("ssh2.sftp://$sftp$remoteFile"));
		file_put_contents($localFile, $contents);
		@fclose($stream);
		return true;
	}

  function getLog() 
  {
     return $this->log; 
  }
}

?>